<template>
  <div class="visuals full-height">
    <div class="visual-content">
      <div class="visual-content-flex">
        <div class="visual-sp">
          <img class="portrait" src="../assets/img/selling_point.png" alt="visual selling point" />
          <img
            class="landscape"
            src="../assets/img/selling_point_landscape.png"
            alt="visual selling point"
          />
        </div>
        <div class="visual-content-flex-bottom">
          <div class="visual-watermark">
            <img src="../assets/img/watermark.png" alt="visual watermark" />
          </div>
          <div class="visual-download">
            <a :href="androidLink" v-if="visibleOS === 'all' || visibleOS === 'AndroidOS'">
              <img src="../assets/img/google_download.png" alt="android download" />
            </a>
            <a :href="iosLink" v-if="visibleOS === 'all' || visibleOS === 'iOS'">
              <img src="../assets/img/ios_download.png" alt="ios download" />
            </a>
          </div>
        </div>
      </div>
      <div class="visual-scrolldown">
        <button @click="changeNextSlide">
          <img
            class="animated infinite fadeInDown delay-2s"
            src="../assets/img/scroll_down.png"
            alt="scroll down"
          />
        </button>
      </div>
    </div>
    <div class="visual-images full-height">
      <div class="visual-fade opacity-animate-wrapper full-height">
        <img
          v-for="(img, index) of kolsPortraitVisuals"
          :src="img"
          :key="`vp-${index}`"
          :class="`visual-img-item opacity-animate portrait ${index === currentVisualIndex ? 'opacity-animate-active' : ''}`"
        />
        <img
          v-for="(img, index) of kolsLandscapeVisuals"
          :src="img"
          :key="`vl-${index}`"
          :class="`visual-img-item opacity-animate landscape ${index === currentVisualIndex ? 'opacity-animate-active' : ''}`"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import MobileDetect from 'mobile-detect';
import { Component, Vue } from 'nuxt-property-decorator';
import { commonModule, SlideName, Orientation } from '@/store/common/const';
import {
  ANDROID_URL,
  IOS_URL,
  KOLS_PORTRAIT_VISUALS,
  KOLS_LANDSCAPE_VISUALS,
  VISUAL_SLIDE_FADE_TIMEOUT
} from '../constants';

@Component
export default class VisualComponent extends Vue {
  protected kolsPortraitVisuals: string[] = KOLS_PORTRAIT_VISUALS;
  protected kolsLandscapeVisuals: string[] = KOLS_LANDSCAPE_VISUALS;
  protected currentVisualIndex: number = 0;
  protected visibleOS = '';
  protected iosLink = IOS_URL;
  protected androidLink = ANDROID_URL;

  @commonModule.Action('changeToSlide')
  protected changeToSlide!: (slide: number) => void;

  protected changeNextSlide() {
    this.changeToSlide(SlideName.Introduce);
  }

  protected beforeMount() {
    // Detect device to download
    const md = new MobileDetect(window.navigator.userAgent);
    if (md.os() === 'AndroidOS') {
      this.visibleOS = 'AndroidOS';
    } else if (md.os() === 'iOS') {
      this.visibleOS = 'iOS';
    } else {
      this.visibleOS = 'all';
    }
  }

  loopFadeEffect() {
    if (this.currentVisualIndex >= this.kolsPortraitVisuals.length - 1) {
      this.currentVisualIndex = 0;
    } else {
      this.currentVisualIndex++;
    }
  }

  mounted() {
    setInterval(this.loopFadeEffect, VISUAL_SLIDE_FADE_TIMEOUT);
  }
}
</script>

<style lang="scss" scoped>
.visuals {
  position: relative;

  .visual-images {
    position: relative;
    z-index: 1;

    .visual-fade {
      position: relative;

      .visual-img-item {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        object-fit: cover;
        z-index: 1;
      }
    }
  }

  .visual-content {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    z-index: 999;

    .visual-content-flex {
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      align-items: center;
      width: 100%;
      height: 80%;
      position: absolute;
      top: 10vh;

      .visual-sp {
        width: 100%;

        img {
          width: 40%;
        }
      }

      .visual-watermark {
        img {
          width: 38%;
          -ms-transform: skewY(-10deg); /* IE 9 */
          -webkit-transform: skewY(-10deg); /* Safari 3-8 */
          transform: skewY(-10deg);
        }
      }

      .visual-download {
        display: flex;
        flex-direction: row;
        justify-content: center;
        align-items: center;
        width: 65%;
        margin: 0 auto;
        margin-top: 3vh;

        a {
          padding: 0 1vh;
          width: 40%;
        }

        img {
          width: 100%;
        }
      }
    }

    .visual-scrolldown {
      position: absolute;
      bottom: 0;
      width: 100%;
      padding: 10px 0;
      background: linear-gradient(
        0deg,
        rgba(0, 0, 0, 0.819765) 50%,
        rgba(0, 0, 0, 0) 100%
      );

      button {
        background-color: transparent;
        border: none;
        outline: none;
      }

      img {
        height: 4vh;
      }
    }
  }
}

@include Orientation(Landscape) {
  .visuals {
    .visual-content {
      .visual-content-flex {
        width: 40%;
        justify-content: center;

        .visual-sp {
          img {
            width: 70%;
          }
        }

        .visual-watermark {
          img {
            width: 70%;
            -ms-transform: skewY(0); /* IE 9 */
            -webkit-transform: skewY(0); /* Safari 3-8 */
            transform: skewY(0);
          }
        }

        .visual-download {
          margin-top: 2vh;

          a {
            padding: 0 10px;
            width: 35%;
          }

          img {
            width: 100%;
          }
        }
      }
    }
  }
}
</style>